## exim4 4.94

=== debian/changelog ===
exim4 (4.94-7ubuntu1) groovy; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Show Ubuntu distribution in SMTP banner
      + d/p/fix_smtp_banner.patch: Show Ubuntu distribution in SMTP banner.
      + Build-Depends on lsb-release to detect Distribution.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 24 Aug 2020 16:36:31 -0400

exim4 (4.94-7) unstable; urgency=low

  * Update from exim-4.94+fixes:
   + 74_24-Taint-fix-ACL-spam-condition-to-permit-tainted-name-.patch
   + 74_25-Fix-debug_print_socket.patch
   + 74_26-debug_print_socket-output-formatting.patch
  * [lintian] Mark some patches with "Forwarded: not-needed".

 -- Andreas Metzler <ametzler@debian.org>  Fri, 24 Jul 2020 13:31:47 +0200

exim4 (4.94-6ubuntu1) groovy; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Show Ubuntu distribution in SMTP banner
      + d/p/fix_smtp_banner.patch: Show Ubuntu distribution in SMTP banner.
      + Build-Depends on lsb-release to detect Distribution.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 13 Aug 2020 13:49:10 -0400

exim4 (4.94-6) unstable; urgency=medium

  * Fix typo (missing "S") in REMOTE_SMTP_SMARTHOST_TLS_VERIFY_HOSTS macro.
    (Thanks, Slavko!)  Closes: #964394
  * Update from exim-4.94+fixes:
    + 74_21-typoes.patch (replaces 75_typo_in_74_20.diff)
    + 74_22-Fix-DKIM-signing-to-always-terminate.-Bug-2295.patch
    + 74_23-Fix-taint-trap-in-parse_fix_phrase-.-Bug-2617.patch
  * Add lintian overrides for usr/lib/sendmail symlink and for not forwarding
    Debian-specific manpages (maintainer-manual-page).
  * [lintian] Use UTF-8 encoding in es.po.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 11 Jul 2020 14:27:31 +0200

exim4 (4.94-5) unstable; urgency=medium

  [ Justin Aplin ]
  * Fix build with GNU Make (<4.3), broken in -3.

  [ Andreas Metzler ]
  * Update from exim-4.94+fixes:
    + 74_15-Cutthrough-handle-request-when-a-callout-hold-is-act.patch
    + 74_16-Lookups-Fix-subdir-filter-on-a-dsearch.patch
    + 74_17-Docs-list-further-ways-domain_data-c-may-be-filled-i.patch
    + 74_18-Sqlite-fix-segfault-on-bad-missing-sqlite_dbfile.-Bu.patch
    + 74_19-Taint-fix-ACL-spam-condition-to-permit-tainted-name-.patch
    + 74_20-Fix-message-reception-clock-usage.-Bug-2615.patch Closes: #962847
  * 75_typo_in_74_20.diff: Fix a typo in
    74_20-Fix-message-reception-clock-usage.-Bug-2615.patch.

 -- Andreas Metzler <ametzler@debian.org>  Fri, 03 Jul 2020 08:20:07 +0200

exim4 (4.94-4) unstable; urgency=medium

  * Automatically version localscanapi provides. Closes: #963251
  * Update from exim-4.94+fixes:
    + 74_14-Fix-string_copy-macro-to-not-multiple-eval-args.-Bug.patch

 -- Andreas Metzler <ametzler@debian.org>  Sun, 21 Jun 2020 18:10:04 +0200

exim4 (4.94-3) unstable; urgency=medium

  * Update from exim-4.94+fixes:
    + 74_09-Filters-fix-vacation-in-Exim-filter.-Bug-2593.patch
    + 74_10-TLS-use-RFC-6125-rules-for-certifucate-name-checks-w.patch
    + 74_11-Taint-fix-radius-expansion-condition.patch
    + 74_12-smtp_accept_map_per_host-call-search_tidyup-in-fail-.patch
    + 74_13-Taint-fix-verify.-Bug-2598.patch

 -- Andreas Metzler <ametzler@debian.org>  Fri, 19 Jun 2020 10:31:26 +0200

exim4 (4.94-2ubuntu1) groovy; urgency=medium

  * Merge with Debian unstable (LP: #1881723). Remaining changes:
    - Show Ubuntu distribution in SMTP banner
      + d/p/fix_smtp_banner.patch: Show Ubuntu distribution in SMTP banner.
      + Build-Depends on lsb-release to detect Distribution.

 -- Bryce Harrington <bryce@canonical.com>  Fri, 12 Jun 2020 01:55:28 +0000

exim4 (4.94-2) unstable; urgency=low

  * Tighten package interdependencies.  With 4.94's daemon avoiding of
    tainting requires usage of $local_part_data instead of $local_part_data
    in mail_spool transport, but this variable is only filled by the
    check_local_user router option in 4.94.
  * Update from exim-4.94+fixes:
    + 74_01-Docs-listitem.patch
    + 74_02-Taint-fix-pam-expansion-condition.-Bug-2587.patch
    + 74_03-Taint-fix-listcount-expansion-operator.-Bug-2586.patch
    + 74_04-Docs-fix-mistaken-variable-name.patch
    + 74_05-Docs-fix-layout.patch
    + 74_06-Docs-typoes.patch
    + 74_07-Taint-fix-multiple-ACL-actions-to-properly-manage-ta.patch
    + 74_08-Fix-bi.-Bug-2590.patch

 -- Andreas Metzler <ametzler@debian.org>  Sun, 07 Jun 2020 09:55:58 +0200

exim4 (4.94-1) unstable; urgency=low

  * New upstream version.
  * Use mktemp(1) instead of tempfile(1), avoid deprecation warning.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 01 Jun 2020 18:45:54 +0200

exim4 (4.94~RC2-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 23 May 2020 18:07:01 +0200

exim4 (4.94~RC1-1) experimental; urgency=low

  * Fix broken cross-reference in exim_lock.8 (Closes: #960356) and sync from
    spec.txt.
  * New upstream version.
    + Drop 75*patch.
    + In ACLs always specify "message" or "log_message" after conditions.
    + Use $local_part_data instead of $local_part in require_files statements.
    + Update example.conf.md5.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 16 May 2020 11:13:48 +0200

exim4 (4.94~RC0-2) experimental; urgency=low

  * Update from upstream GIT master.
    + 75_06-Debug-socket-details.patch
    + 75_08-Fix-build-on-platforms-not-supporting-sockopt-SO_PRO.patch
    + 75_09-Build-fix-parallelism-problem.-Bug-2566.patch
    + 75_11-Make-bounce-warn-_message_file-expanded.-Bug-2522.patch
    + 75_12-Taint-When-a-non-wildcarded-localpart-affix-is-match.patch
    + 75_14-Consolidate-local_part_verified-into-local_part_data.patch
    + 75_17-Ensure-lookup-result-variables-are-dropped-between-m.patch
    + 75_18-tidying.patch
    + 75_19-Fix-SPA-authenticator-checking-client-supplied-data-.patch
    + 75_20-wip-see-failed-summary.log.list_match_value.-Pretty-.patch
    + 75_21-value-return.patch


=== debian/control ===
Source: exim4
Section: mail
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
 Marc Haber <mh+debian-packages@zugschlus.de>
Homepage: https://www.exim.org/
Standards-Version: 4.5.0
Rules-Requires-Root: binary-targets
Vcs-Git: https://salsa.debian.org/exim-team/exim4.git
Vcs-Browser: https://salsa.debian.org/exim-team/exim4
Build-Depends:
 debhelper-compat (= 12),
 default-libmysqlclient-dev,
 docbook-xml,
 docbook-xsl,
 libdb5.3-dev,
 libgnutls28-dev (>= 3.5.7),
 libident-dev,
 libidn11-dev,
 libidn2-dev,
 libldap2-dev,
 libpam0g-dev,
 libpcre3-dev,
 libperl-dev,
 libpq-dev,
 libsasl2-dev,
 libsqlite3-dev,
 libx11-dev,
 libxaw7-dev,
 libxext-dev,
 libxmu-dev,
 libxt-dev,
 lynx,
 po-debconf,
 xsltproc,
 lsb-release

Package: exim4-base
Architecture: any
Priority: optional
Breaks:
 exim4-daemon-custom (<<${Upstream-Version}),
 exim4-daemon-heavy (<<${Upstream-Version}),
 exim4-daemon-light (<<${Upstream-Version})
Conflicts: exim, exim-tls
Replaces:
 exim,
 exim-tls,
 exim4-daemon-custom,
 exim4-daemon-heavy,
 exim4-daemon-light
Depends:
 adduser,
 cron | cron-daemon | anacron | systemd-sysv,
 exim4-config (>=4.94) | exim4-config-2,
 lsb-base (>= 3.0-6),
 netbase,
 ${misc:Depends},
 ${shlibs:Depends}
# psmisc just for exiwhat.
Recommends: mailx, psmisc
Suggests:
 exim4-doc-html | exim4-doc-info,
 eximon4,
 file,
 gnutls-bin | openssl,
 mail-reader,
 spf-tools-perl,
 swaks
Description: support files for all Exim MTA (v4) packages
 Exim (v4) is a mail transport agent. exim4-base provides the support
 files needed by all exim4 daemon packages. You need an additional package
 containing the main executable. The available packages are:
 .
  exim4-daemon-light
  exim4-daemon-heavy
 .
 If you build exim4 from the source package locally, you can also
 build an exim4-daemon-custom package tailored to your own feature set.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-config
Architecture: all
Priority: optional
Breaks:
 exim4-daemon-heavy (<< 4.94),
 exim4-daemon-light (<< 4.94)
Provides: exim4-config-2
Conflicts:
 exim,
 exim-tls,
 exim4-config,
 exim4-config-2,
 ${MTA-Conflicts}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Description: configuration for the Exim MTA (v4)
 Exim (v4) is a mail transport agent. exim4-config provides the configuration
 for the exim4 daemon packages. The configuration framework has been split
 off the main package to allow sites to replace the configuration scheme
 with their own without having to change the actual exim4 packages.
 .
 Sites with special configuration needs (having a lot of identically
 configured machines for example) can use this to distribute their own
 custom configuration via the packaging system, using the magic
 available with dpkg's conffile handling, without having to do local
 changes on all of these machines.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-light
Architecture: any
Priority: optional
Provides:
 exim4-localscanapi-3.1,
 mail-transport-agent,
 ${dist:Provides:exim4-daemon-light}
Conflicts: mail-transport-agent
Replaces: exim4-base (<= 4.61-1), mail-transport-agent
Depends:
 exim4-base (>= ${Upstream-Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight Exim MTA (v4) daemon
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with only basic features enabled. It works well with the
 standard setups that are provided by Debian and includes support for
 TLS encryption and the dlopen patch to allow dynamic loading of a
 local_scan function.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4
Architecture: all
Priority: optional
Depends:
 debconf (>= 1.4.69) | cdebconf (>= 0.39),
 exim4-base (<< ${source:Version}.1),
 exim4-base (>= ${source:Version}),
 exim4-daemon-light (>= ${source:Version}) |
 exim4-daemon-heavy (>= ${source:Version}) |
 exim4-daemon-custom (>= ${source:Version}),
 ${misc:Depends}
Description: metapackage to ease Exim MTA (v4) installation
 Exim (v4) is a mail transport agent. exim4 is the metapackage depending
 on the essential components for a basic exim4 installation.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-heavy
Architecture: any
Priority: optional
Provides:
 ${localscanabiversion},
 mail-transport-agent
Conflicts: mail-transport-agent
Replaces: exim4-base (<= 4.61-1), mail-transport-agent
Depends:
 exim4-base (>= ${Upstream-Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks: clamav-daemon (<< 0.95)
Description: Exim MTA (v4) daemon with extended features, including exiscan-acl
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with extended features. In addition to the features already
 supported by exim4-daemon-light, exim4-daemon-heavy includes LDAP,
 sqlite, PostgreSQL and MySQL data lookups, SASL and SPA SMTP authentication,
 embedded Perl interpreter, and the content scanning extension
 (formerly known as "exiscan-acl") for integration of virus scanners
 and spamassassin.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

#Package: exim4-daemon-custom
#Architecture: any
#Priority: optional
#Provides: exim4-localscanapi-3.1, mail-transport-agent
#Conflicts: mail-transport-agent
#Replaces: exim4-base (<= 4.61-1), mail-transport-agent
#Depends:
# exim4-base (>= ${Upstream-Version}),
# ${misc:Depends},
# ${shlibs:Depends}
#Description: custom Exim MTA (v4) daemon with locally set features
# Exim (v4) is a mail transport agent. This package contains a
# custom-configured exim4 daemon compiled to local needs. This package
# is not part of official Debian, but can easily be built from the
# Debian source package. For information about the feature set compiled in,
# and for bug reports, please find out who built your package.
# .
# The Debian exim4 packages have their own web page,
# http://wiki.debian.org/PkgExim4. There is also a Debian-specific
# FAQ list. Information about the way the Debian packages are
# configured can be found in
# /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
# information about the way the Debian binary packages are built. The
# very extensive upstream documentation is shipped in
# /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
# configuration process in a standard setup, invoke dpkg-reconfigure
# exim4-config. There is a Debian-centered mailing list,
# pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
# questions there, and only write to the upstream exim-users mailing
# list if you are sure that your question is not Debian-specific. You
# can find the subscription web page on
# http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: eximon4
Architecture: any
Priority: optional
Conflicts: eximon
Replaces: eximon
Depends: exim4-base (>= 4.10), ${misc:Depends}, ${shlibs:Depends}
Description: monitor application for the Exim MTA (v4) (X11 interface)
 Eximon is a helper program for the Exim MTA (v4). It allows
 administrators to view the mail queue and logs, and perform a variety
 of actions on queued messages, such as freezing, bouncing and thawing
 messages.

Package: exim4-dev
Architecture: any
Priority: optional
Depends: ${misc:Depends}
Description: header files for the Exim MTA (v4) packages
 Exim (v4) is a mail transport agent. This package contains header
 files that can be used to compile code that is then dynamically linked
 to exim's local_scan interface.
 .
 The Debian exim4 packages have their own web page,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for exim4
# This file is public domain software, originally written by Joey Hess.
#
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# avoid uname -m detection
ifdef DEB_TARGET_GNU_CPU
export EXIM_ARCHTYPE = $(DEB_TARGET_GNU_CPU)
else
export EXIM_ARCHTYPE = $(shell dpkg-architecture -qDEB_TARGET_GNU_CPU)
endif

buildname = $(shell scripts/os-type)-$(shell scripts/arch-type)
DEBIAN =    $(CURDIR)/debian

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
# SOURCE_DATE_EPOCH is exported by pkg-info.mk since dpkg 1.18.8/July 2016
# fall back to current date otherwise. Still needed since debhelper 12
# only depends on dpkg-dev (>= 1.18.2~).
SOURCE_DATE_EPOCH ?= $(shell date '+%s')

EXIM4VERSIONLOCALSCAN = \
	$(shell sed -rn \
	's/^\s*.define LOCAL_SCAN_ABI_VERSION_(MAJOR|MINOR)\s*([0-9]+).*/\2/p' \
	src/local_scan.h | \
	{ read MAJOR; read MINOR; echo $${MAJOR}.$${MINOR} ; }\
	)

# The build system ignores CPPFLAGS, append them to CFLAGS
CFLAGS += $(shell getconf LFS_CFLAGS) -D_LARGEFILE_SOURCE \
	  -fno-strict-aliasing -Wall $(CPPFLAGS)
export CFLAGS
# LFLAGS is used where GNU would use LDFLAGS
export LFLAGS = $(LDFLAGS)

LC_ALL=C
export LC_ALL

# If you want to build a daemon with a configuration tailored to YOUR special
# needs, uncomment the exim4-daemon-custom package in debian/control,
# call "debian/rules unpack-configs", copy EDITME.exim4-light to
# EDITME.exim4-custom and modify it, then call "debian/rules pack-configs".
#
# Afterwards EITHER uncomment the customdaemon definition below, or set it
# to the desired value via the environment.
# e.g run:
# env customdaemon=exim4-daemon-custom dpkg-buildpackage -uc -us
#
# If you want to create multiple custom packages with different names, use
# the script debian/create-custom-package [suffix].

# customdaemon = exim4-daemon-custom
daemons = exim4-daemon-light exim4-daemon-heavy $(customdaemon)

# If you want to build with OpenSSL instead of GnuTLS, uncomment this
# OPENSSL:=1
# Please note that building exim4-daemon-heavy with OpenSSL is a GPL
# violation.

PROVIDE_DEFAULT_MTA = $(shell if dpkg-vendor --is Ubuntu || \
	dpkg-vendor --derives-from Ubuntu ; then : ; else \
	echo "default-mta" ; fi)
# for reproducible build. If set exim would use $TZ as default value for
# TIMEZONE_DEFAULT
undefine TZ
unexport TZ


unpack-configs: unpack-configs-stamp

unpack-configs-stamp: src/EDITME exim_monitor/EDITME
	patch -o EDITME.eximon exim_monitor/EDITME \
		$(DEBIAN)/EDITME.eximon.diff
	patch -o EDITME.exim4-light src/EDITME \
		$(DEBIAN)/EDITME.exim4-light.diff
ifdef OPENSSL
	patch EDITME.exim4-light $(DEBIAN)/EDITME.openssl.exim4-light.diff
endif
	for editme in $(DEBIAN)/EDITME.exim4-*.diff; do \
	  if [ "$$editme" != "$(DEBIAN)/EDITME.exim4-light.diff" ]; then \
	    TARGETNAME=`basename $$editme .diff`; \
	    echo patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
	    patch -o $$TARGETNAME EDITME.exim4-light $$editme || \
	    exit $$? ;\
	  fi; \
	done
	touch unpack-configs-stamp

pack-configs:
	-diff -u src/EDITME EDITME.exim4-light \
		> $(DEBIAN)/EDITME.exim4-light.diff
	-for editme in EDITME.exim4-*; do \
	  if [ "$$editme" != "EDITME.exim4-light" ]; then \
	    echo diff -u EDITME.exim4-light $$editme; \
	    diff -u EDITME.exim4-light $$editme > $(DEBIAN)/$${editme}.diff; \
	  fi; \
	done
	-diff -u exim_monitor/EDITME EDITME.eximon \
		> $(DEBIAN)/EDITME.eximon.diff

bdir-stamp: unpack-configs-stamp
	for i in $(daemons) ; do \
		mkdir b-$$i && \
		find . -mindepth 1 -maxdepth 1 \
		-name debian -prune -o \
		-name 'b-*' -o -print0 | \
		xargs --no-run-if-empty --null \
		cp -a --target-directory=b-$$i ; \
	done
	touch $@

override_dh_auto_configure: unpack-configs-stamp bdir-stamp
	for i in $(daemons) ; do \
		mkdir -p b-$$i/Local && \
		cp EDITME.`echo $$i | sed -e s/exim4-daemon/exim4/` \
		b-$$i/Local/Makefile && \
		cp EDITME.eximon b-$$i/Local/eximon.conf ;\
		done

override_dh_auto_build:
	set -e ; for i in $(daemons) ; do \
		echo building $$i; \
		cd $(CURDIR)/b-$$i && \
		$(MAKE) FULLECHO='' ; \
		done
	# Which version of Berkeley DB are we building against?
	printf '#include <db.h>\ninstdbversionis DB_VERSION_MAJOR DB_VERSION_MINOR\n' | \
		cpp -P | grep instdbversionis |\
		sed -e 's/[[:space:]]*instdbversionis[[:space:]]//' \
		-e 's/[[:space:]][[:space:]]*/./' \
		-e 's_^_s/^BDBVERSION=.*/BDBVERSION=_' \
		-e 's_$$_/_' \
		> $(DEBIAN)/berkeleydb.sed
	# Store Berkeley DB version in postinst script.
	sed -i -f $(DEBIAN)/berkeleydb.sed \
		$(DEBIAN)/exim4-base.postinst
	# symlink identical maintainerscripts
	for i in `echo $(daemons) | sed -e s/exim4-daemon-light//` ; do \
		ln -sfv exim4-daemon-light.prerm \
			"$(DEBIAN)/$$i.prerm" ; \
		ln -sfv exim4-daemon-light.postinst \
			"$(DEBIAN)/$$i.postinst" ; \
	done

override_dh_auto_install-arch: debian/README.Debian
	cd b-exim4-daemon-light && \
	  $(MAKE) install FULLECHO='' \
		INSTALL_ARG=-no_symlink \
		inst_conf=$(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf \
		inst_aliases=$(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/aliases \
		inst_dest=$(DEBIAN)/exim4-base/usr/sbin
	if [ -e "$(DEBIAN)/example.conf.md5" ] && [ "$$(< $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf md5sum)" != "$$(cat $(DEBIAN)/example.conf.md5)" ] ; then \
	  echo "upstream example configuration has changed, new md5sum:"; \
	  < $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf md5sum; \
	  echo "aborting build."; \
	  exit 1; \
	fi
	< $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf md5sum > $(DEBIAN)/example.conf.md5
	sed -e 's,/[a-zA-Z/0-9.-]*exim4-base/examples/,/etc/,' \
		< $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf \
		> $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf.tmp
	mv $(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf.tmp \
		$(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples/example.conf
	install -m755 b-exim4-daemon-light/build-$(buildname)/convert4r4 \
		$(DEBIAN)/exim4-base/usr/sbin/exim_convert4r4
	install -m755 \
		b-exim4-daemon-light/build-$(buildname)/transport-filter.pl \
		b-exim4-daemon-light/util/ratelimit.pl \
		$(DEBIAN)/exim4-base/usr/share/doc/exim4-base/examples
	rm $(DEBIAN)/exim4-base/usr/sbin/exim
	mv $(DEBIAN)/exim4-base/usr/sbin/eximon \
		$(DEBIAN)/eximon4/usr/sbin
	mv $(DEBIAN)/exim4-base/usr/sbin/eximon.bin \
		$(DEBIAN)/eximon4/usr/libexec/exim4
	pod2man --center=EXIM4 --section=8 \
		$(DEBIAN)/exim4-base/usr/sbin/exipick \
		$(DEBIAN)/exim4-base/usr/share/man/man8/exipick.8
	pod2man --center=EXIM4 --section=8 \
		$(DEBIAN)/exim4-base/usr/sbin/eximstats \
		$(DEBIAN)/exim4-base/usr/share/man/man8/eximstats.8
	install -m755 $(DEBIAN)/syslog2eximlog $(DEBIAN)/exim4-base/usr/sbin/
	pod2man --center=EXIM4 --section=8 \
		$(DEBIAN)/syslog2eximlog \
		$(DEBIAN)/exim4-base/usr/share/man/man8/syslog2eximlog.8
	for i in b-exim4-daemon-*/build-$(buildname)/exim ; do \
		install -m4755 -oroot -groot $$i \
		$(DEBIAN)/`echo $$i | sed -e 's/^b-//' -e 's_/.*__'`/usr/sbin/exim4 ; \
		done

override_dh_auto_install-indep: debian/README.Debian
	# if you change anything here, you will have to change
	# config-custom/debian/rules as well
	sed -e \
	"s/^UPEX4C_version=\"\"/UPEX4C_version=\"$(DEB_VERSION)\"/" \
	< $(DEBIAN)/debconf/update-exim4.conf \
	> $(DEBIAN)/exim4-config/usr/sbin/update-exim4.conf
	chmod 755 $(DEBIAN)/exim4-config/usr/sbin/update-exim4.conf
	install -m 755 $(DEBIAN)/update-exim4defaults \
		$(DEBIAN)/exim4-config/usr/sbin

	cd $(DEBIAN)/debconf/conf.d && \
		tar cf - `find \( -path '*/.svn/*' -prune \) -or \
		\( -type f -print \)` | \
		{ cd $(DEBIAN)/exim4-config/etc/exim4/conf.d/ && \
		tar xf - ; }

	install -m644 $(DEBIAN)/email-addresses $(DEBIAN)/exim4-config/etc/
	install -m640 -oroot -groot $(DEBIAN)/passwd.client \

## exim4 4.94.2

=== src/transports/Makefile ===
# Make file for building a library containing all the available transports and
# calling it transports.a. This is called from the main make file, after cd'ing
# to the transports subdirectory.

OBJ = appendfile.o autoreply.o lmtp.o pipe.o queuefile.o smtp.o smtp_socks.o tf_maildir.o

transports.a:    $(OBJ)
		 @$(RM_COMMAND) -f transports.a
		 @echo "$(AR) transports.a"
		 @$(AR) transports.a $(OBJ)
		 $(RANLIB) $@

.SUFFIXES:       .o .c
.c.o:;           @echo "$(CC) $*.c"
		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c

appendfile.o:    $(HDRS) appendfile.c appendfile.h tf_maildir.h
autoreply.o:     $(HDRS) autoreply.c autoreply.h
lmtp.o:          $(HDRS) lmtp.c lmtp.h
pipe.o:          $(HDRS) pipe.c pipe.h
queuefile.o:     $(HDRS) queuefile.c queuefile.h
smtp.o:          $(HDRS) smtp.c smtp.h
smtp_socks.o:    $(HDRS) smtp_socks.c smtp.h

tf_maildir.o:    $(HDRS) tf_maildir.c tf_maildir.h appendfile.h

# End

=== debian/changelog ===
exim4 (4.94.2-7+deb11u3) bullseye-security; urgency=medium

   * Fix parsing of multiline RFC 2231 header filename parameter in mime ACL.
     CVE-2024-39929 Closes: #1075785

 -- Andreas Metzler <ametzler@debian.org>  Tue, 09 Jul 2024 11:01:33 +0200

exim4 (4.94.2-7+deb11u2) bullseye-security; urgency=high

  * 79_CVE-2023-51766_4.97.1-release.diff from 4,97.1 release: Refuse to
    accept a line "dot, LF" as end-of-DATA unless operating in LF-only mode
    (as detected from the first header line) to fix smtp-smuggling
    (CVE-2023-51766). Closes: #1059387

 -- Andreas Metzler <ametzler@debian.org>  Mon, 01 Jan 2024 18:00:11 +0100

exim4 (4.94.2-7+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Address external and SPA authenticator vulnerabilities (CVE-2023-42114,
    CVE-2023-42115, CVE-2023-42116)
    - Auths: fix possible OOB write in external authenticator (CVE-2023-42115)
    - Auths: use uschar more in spa authenticator
    - Auths: fix possible OOB write in SPA authenticator (CVE-2023-42116)
    - Auths: fix possible OOB read in SPA authenticator (CVE-2023-42114)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 29 Sep 2023 23:23:04 +0200

exim4 (4.94.2-7) unstable; urgency=medium

  * 73_05-Fix-tainted-message-for-fakereject.patch from upstream +fixes
    branch: Fix re-expansion of custom message with control=fakereject.

 -- Andreas Metzler <ametzler@debian.org>  Tue, 13 Jul 2021 18:04:57 +0200

exim4 (4.94.2-6) unstable; urgency=medium

  * Cherrypick
    78_01-Command-line-option-for-no-notifier-socket.-Bug-2616.patch from
    upstream GIT master. This allows one to disable creation of a
    daemon notifier socket by either setting notifier_socket to a empty value
    or specifying -oY commandline option.
  * Init script: For QUEUERUNNER='separate' start daemons with -oY commandline
    option to disable daemon notifier socket. Enforce lockstep ugrade of -base
    and *daemon* by temporarily adding a versioned Breaks to exim4-base on
    older *daemon*. Closes: #988844

 -- Andreas Metzler <ametzler@debian.org>  Wed, 26 May 2021 18:49:44 +0200

exim4 (4.94.2-5) unstable; urgency=high

  * 73_04-Fix-host_name_lookup-Close-2747.patch from exim-4.94.2+fixes.
    Fix regression in 4.94.2.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 17 May 2021 17:45:00 +0200

exim4 (4.94.2-4) unstable; urgency=high

  * 75_27_Fix-logging-with-empty-element-in-log_file_path-Bug-.patch /
    75_28_Fix-logging-with-build-time-config-and-empty-element.patch replacing
    75_27_open_logs_2744.patch from upstream exim-4.94.2+taintwarn branch:
    Fix null-pointer dereference when logging to syslog (Closes: #988086) and
    also fix loging to syslog at all (Closes: #988304)

 -- Andreas Metzler <ametzler@debian.org>  Sat, 15 May 2021 18:16:08 +0200

exim4 (4.94.2-3) unstable; urgency=medium

  * Updates from exim-4.94.2+fixes:
    + 73_03-Named-Queues-fix-immediate-delivery.-Bug-2743.patch
      Fix false positive taint error when using named queues.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 13 May 2021 18:53:53 +0200

exim4 (4.94.2-2) unstable; urgency=medium

  * Updates from exim-4.94.2+fixes:
    + 73_01-Fix-DANE-SNI-handling-Bug-2265.patch (from +fixes).
      Fix broken SNI/DANE handling.
    + 73_02-Fix-ipv6norm.patch: Fix ${ip6norm:} operator.  Previously, any
      trailing line text was dropped, making it unusable in complex
      expressions.
  * 75_27_open_logs_2744.patch Partial fix for nullpointer dereference with
      logging to syslog. See 988086.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 09 May 2021 18:03:15 +0200

exim4 (4.94.2-1) unstable; urgency=high

  * New upstream security release.
    + Release based on +fixes branch, drop 74_*diff.
    + Unfuzz 75_04-acl.patch.
    + Merge in upstream configuration change rejecting all RCPT commands after
      too many (more than five out of the initial ten) bad recipients. Can be
      disabled by setting CHECK_RCPT_NO_FAIL_TOO_MANY_BAD_RCPT.
    + Fixes multiple security vulnerabilities reported by Qualys and adds
      related robustness improvements. (Special thanks to Heiko)
      CVE-2020-28023: Out-of-bounds read in smtp_setup_msg()
      CVE-2020-28007: Link attack in Exim's log directory
      CVE-2020-28016: Heap out-of-bounds write in parse_fix_phrase()
      CVE-2020-28012: Missing close-on-exec flag for privileged pipe
      CVE-2020-28024: Heap buffer underflow in smtp_ungetc()
      CVE-2020-28009: Integer overflow in get_stdinput()
      CVE-2020-28015, CVE-28021: New-line injection into spool header file
      CVE-2020-28026: Line truncation and injection in spool_read_header()
      CVE-2020-28022: Heap out-of-bounds read and write in extract_option()
      CVE-2020-28017: Integer overflow in receive_add_recipient()
      CVE-2020-28013: Heap buffer overflow in parse_fix_phrase()
      CVE-2020-28011: Heap buffer overflow in queue_run()
      CVE-2020-28010: Heap out-of-bounds write in main()
      CVE-2020-28018: Use-after-free in tls-openssl.c
      CVE-2020-28025: Heap out-of-bounds read in pdkim_finish_bodyhash()
      CVE-2020-28014, CVE-2021-27216: PID file handling
      CVE-2020-28008: Assorted attacks in Exim's spool directory
      CVE-2020-28019: Failure to reset function pointer after BDAT error
  * Update debian/upstream/signing-key.asc from
    <https://downloads.exim.org/Exim-Maintainers-Keyring.asc>.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 02 May 2021 07:22:06 +0200

exim4 (4.94-19) unstable; urgency=medium

  * Further updates from heiko/exim-4.94+fixes+taintwarn:
    + 75_24-Silence-the-compiler.patch
    + 75_26-Disable-taintchecks-for-mkdir-this-isn-t-part-of-4.9.patch
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 26 Apr 2021 18:35:43 +0200

exim4 (4.94-18) experimental; urgency=medium

  * Pull patches to temporarily add an option to turn taint errors into
    warnings. (See #987133)


=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
+# * -base and daemon of the same upstream version enforced by a Breaks
+#   in -base and a versioned Depends of the daemon-packages on -base
+# * -base depends on -config, without automatic versioning.
 Source: exim4
 Section: mail
 Priority: standard
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
+Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
 Uploaders:
  Andreas Metzler <ametzler@debian.org>,
  Marc Haber <mh+debian-packages@zugschlus.de>
 Homepage: https://www.exim.org/
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: binary-targets
 Vcs-Git: https://salsa.debian.org/exim-team/exim4.git
 Vcs-Browser: https://salsa.debian.org/exim-team/exim4
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  default-libmysqlclient-dev,
  docbook-xml,
  docbook-xsl,
@@ -35,8 +37,7 @@
  libxt-dev,
  lynx,
  po-debconf,
- xsltproc,
- lsb-release
+ xsltproc
 
 Package: exim4-base
 Architecture: any
@@ -44,7 +45,10 @@
 Breaks:
  exim4-daemon-custom (<<${Upstream-Version}),
  exim4-daemon-heavy (<<${Upstream-Version}),
- exim4-daemon-light (<<${Upstream-Version})
+ exim4-daemon-light (<<${Upstream-Version}),
+ exim4-daemon-custom (<< 4.94.2-6~),
+ exim4-daemon-heavy (<< 4.94.2-6~),
+ exim4-daemon-light (<< 4.94.2-6~)
 Conflicts: exim, exim-tls
 Replaces:
  exim,
@@ -111,6 +115,7 @@
  exim4-config-2,
  ${MTA-Conflicts}
 Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
+Recommends: ca-certificates
 Description: configuration for the Exim MTA (v4)
  Exim (v4) is a mail transport agent. exim4-config provides the configuration
  for the exim4 daemon packages. The configuration framework has been split
@@ -143,7 +148,7 @@
 Architecture: any
 Priority: optional
 Provides:
- exim4-localscanapi-3.1,
+ ${localscanabiversion},
  mail-transport-agent,
  ${dist:Provides:exim4-daemon-light}
 Conflicts: mail-transport-agent
@@ -247,7 +252,7 @@
 #Package: exim4-daemon-custom
 #Architecture: any
 #Priority: optional
-#Provides: exim4-localscanapi-3.1, mail-transport-agent
+#Provides: ${localscanabiversion}, mail-transport-agent
 #Conflicts: mail-transport-agent
 #Replaces: exim4-base (<= 4.61-1), mail-transport-agent
 #Depends:
@@ -294,8 +299,3 @@
 Priority: optional
 Depends: ${misc:Depends}
 Description: header files for the Exim MTA (v4) packages
- Exim (v4) is a mail transport agent. This package contains header
- files that can be used to compile code that is then dynamically linked
- to exim's local_scan interface.
- .
- The Debian exim4 packages have their own web page,

=== debian/tests/control ===
Tests: basic
Depends: exim4, swaks, libnet-ssleay-perl
Restrictions: allow-stderr
